package jwiki;

/** Used to compare objects of a given class for size. 
** If "this" is "less" than (comes before) other, then compareTo should return a negative.
** If they are the same, then it should return 0.
** otherwise it should return a positive. 
** Note that this interface is provided by recent versions of java.lang. 
** We use our own here to make this usable with jdk1.1.7
**
** This should be compatible with the class's equals method. If a.equals(b) then 
** a.compareTo(b) should be 0. 
**
** If a.compareTo(b) < 0 then b.compareTo(a) should be > 0. 
*/
interface Comparable
{	int compareTo(Object other);
}