package jwiki;

import java.io.*;
import java.util.*;

/** Does the edit function of JWiki **/
public class edit implements WikiPostable {

    public void handlePOST(JHandler h, byte buf[], int bufSize)
        throws Exception
    {
		Hashtable fhdr; // The file header fields.

        // Parse the content part of the request into seperate items.
        // The key is the var name and the data is the value of the
        // var.
        Hashtable vars = h.parsePOST(buf, bufSize);
		Hashtable cookies = new Hashtable();

        String fileName = (String)vars.get("file");
        if(fileName == null)
        {
            h.transmitString("Filename Error",
             "No file name specified in the POST.<BR> The INPUT HTML must be wrong.");
            return;
        }

        String Submit = (String)vars.get("Submit");
		if(Submit == null || Submit.equalsIgnoreCase("edit this page"))
			Submit = "Edit";

		if(Submit.equals("Edit") && h.getEditLock(fileName) == false)
		{
			h.transmitString("Conflict Error","Someone is editing the page " + fileName + ". (Or the file does not exist.)");
			return;
		}

        FileInputStream f = null;

        if(Submit.equals("Edit"))
		{
        	try
        	{
            	f = new FileInputStream(
                	h.getParent().getRoot() + File.separator +
                	"docs" + File.separator + fileName);
        	}
        	catch(Exception oe)
        	{
           		h.transmitString("Page Not Found Error", "Can not open page.");
                h.releaseEditLock(fileName);
             	return;
        	}
        	fhdr = h.readHeader(f, cookies);
  //          System.out.println(""+fhdr);
		}
		else
		{
			// Is it already in existance?
			File fil = new File(h.getParent().getRoot() + File.separator +
                	"docs" + File.separator + fileName);
			if(fil.exists())
			{
				h.transmitString("Page Exists Error", "The page <B>" + fileName + "</B> already exists.");
				h.releaseEditLock(fileName);
                return;
			}

			// Set to defaults.
        	fhdr = new Hashtable();
			fhdr.put("read", JWiki.readPermission());
			fhdr.put("write", JWiki.writePermission());
			fhdr.put("preamble", JWiki.usePreamble());
			fhdr.put("postamble", JWiki.usePostamble());
			fhdr.put("editbutton", JWiki.showEditButton());
			fhdr.put("html", JWiki.allowHtml());
            fhdr.put("wiki", JWiki.allowWiki());
		}



        //OutputStream out = h.getOut();
//        h.sendString("HTTP/1.0 200 Ok");
//        h.crlf();
		h.httpHeader();
        // Headers
        // This keeps the browser from expecting a persistant connection.
        h.sendString("Connection: close");
        h.crlf();
        h.crlf();

        h.startPage("Edit of Page: "+ fileName, false);

        h.sendString("Make sure you exit this edit page with the <B>Save</B>\n");
        h.sendString("or <B>Cancel</B> button. \n Otherwise the page lock won't be released.");
        h.sendString("Wait for the entire page to load.");

		String readPerm = (String)fhdr.get("read");
		String writePerm = (String)fhdr.get("write");
		String rPassword = (String)fhdr.get("rpass");
		String wPassword = (String)fhdr.get("wpass");

		if(writePerm == null || writePerm.equals("none"))
		{
			try { f.close(); } catch (Exception fe) { }
            h.sendString("\n<h3>You do not have permission to edit that page.</h3>");
            h.endPage();
            h.releaseEditLock(fileName);
            return;
		}

		if(writePerm.equals("passwd") && !h.userLoggedIn())
		{
			try { f.close(); } catch (Exception fe) { }
            h.sendString("\n<h3>Password protected: You must supply a password to edit that page.</h3>\n");
 //           h.sendLoginForm();
 			h.sendString("<BR><form method=\"post\" action=\"password\">\n" +
 			"Page:<INPUT TYPE=text name=page VALUE=" + fileName +" cols=20><BR>\n" +
 			"<input type=\"Submit\" name=Submit value=\"Password\">\n"  +
 			"<input type=\"Hidden\" name=kind value=\"Write\">\n" +
 			"</form>" +
 			"\n&nbsp;The next page will accept your password."
 			);
            h.endPage();
            h.releaseEditLock(fileName);
            return;
		}

        // Now the body of the form.
        /* IMPORTANT NOTE: The save button was removed from the top of a page. The
        	remaining button is at the bottom. With a button at the top it was possible to
            save the page before the edit form completely loaded. The POST would then be
            incomplete. This resulted in truncated files being saved which meant that
            either you lost content or (worse) you lost the page characteristics. The file
            would then become corupted and the page became unusable.
        */
        h.sendString("<FORM METHOD=POST ACTION=editsave>\n");
 //       h.sendString("<INPUT TYPE=\"Submit\" NAME=Submit VALUE=\"Save\">\n");
        h.sendString("<INPUT TYPE=\"Submit\" NAME=Submit VALUE=\"Cancel\"><P>\n");
        h.sendString("<TEXTAREA name=txt cols=80 rows=15>\n");

        String contents;
        if(Submit.equals("Edit"))
        {
        	contents = h.getFile(f);
		}
		else
		{
			contents = "Type the new page contents here.";
		}

        if(Submit.equals("Edit"))
			try { f.close(); } catch (Exception fe) { }

        contents = h.safeHTML(contents);
        h.sendString(contents);

        h.sendString("</TEXTAREA><BR>\n");
        h.sendString("<INPUT TYPE=HIDDEN NAME=\"file\" VALUE=\"" + fileName + "\">\n");

        h.sendString("<P>");

        h.sendString("<INPUT TYPE=\"Submit\" NAME=Submit VALUE=\"Save\">\n");
        h.sendString("<INPUT TYPE=\"Submit\" NAME=Submit VALUE=\"Cancel\">\n");

        h.sendString("<P>");

        String temp = (String)fhdr.get("html");
        if(temp != null && temp.equalsIgnoreCase("TRUE"))
            h.sendString("Allow HTML:<INPUT TYPE=checkbox CHECKED NAME=html VALUE=\"html\">\n");
        else
            h.sendString("Allow HTML:<INPUT TYPE=checkbox NAME=html VALUE=\"html\">\n");

        h.sendString("<BR>");
        temp = (String)fhdr.get("wiki");
        if(temp != null && temp.equalsIgnoreCase("TRUE"))
            h.sendString("Wiki:<INPUT TYPE=checkbox CHECKED NAME=wiki VALUE=\"wiki\">\n");
        else
            h.sendString("Wiki:<INPUT TYPE=checkbox NAME=wiki VALUE=\"wiki\">\n");

        h.sendString("<BR>");
        temp = (String)fhdr.get("preamble");
        if(temp != null && temp.equalsIgnoreCase("TRUE"))
            h.sendString("Preamble:<INPUT TYPE=checkbox CHECKED NAME=preamble VALUE=preamble>\n");
        else
            h.sendString("Preamble:<INPUT TYPE=checkbox NAME=preamble VALUE=preamble>\n");

        h.sendString("<BR>");
        temp = (String)fhdr.get("postamble");
        if(temp != null && temp.equalsIgnoreCase("TRUE"))
            h.sendString("Postamble:<INPUT TYPE=checkbox CHECKED NAME=postamble VALUE=postamble>\n");
        else
            h.sendString("Postamble:<INPUT TYPE=checkbox NAME=postamble VALUE=postamble>\n");

        h.sendString("<BR>");
        temp = (String)fhdr.get("editbutton");
        if (temp != null && temp.equalsIgnoreCase("TRUE"))
        {   h.sendString("Show edit button:<INPUT TYPE=checkbox CHECKED NAME=editbutton VALUE=editbutton>\n");
       	}
        else
             h.sendString("Show edit button:<INPUT TYPE=checkbox NAME=editbutton VALUE=editbutton>\n");
        h.sendString("<B>Warning:</B> Once you turn this off you can only turn it on by editing the file directly on the server machine.<BR>\n");

		if(writePerm == null || writePerm.equals("all"))
            h.sendString("Write Permission:<INPUT TYPE=radio CHECKED NAME=writePerm VALUE=all>all&nbsp;\n");
		else
            h.sendString("Write Permission:<INPUT TYPE=radio NAME=writePerm VALUE=all>all&nbsp;\n");

		if(writePerm.equals("passwd"))
            h.sendString("<INPUT TYPE=radio CHECKED NAME=writePerm VALUE=passwd>password required&nbsp;\n");
		else
            h.sendString("<INPUT TYPE=radio NAME=writePerm VALUE=passwd>password required&nbsp;\n");
        h.sendString("|| WritePassword ");
		if(wPassword == null || wPassword.equals(""))
			h.sendString("<INPUT TYPE=text name=wpass cols=20> \n");
		else
			h.sendString("<INPUT TYPE=text name=rpass value="+wPassword+" cols=20> \n");

		if(writePerm.equals("none"))
            h.sendString("<INPUT TYPE=radio CHECKED NAME=writePerm VALUE=none>not writeable <BR>");
		else
            h.sendString("<INPUT TYPE=radio NAME=writePerm VALUE=none>not writeable <BR>");
		if(readPerm == null || readPerm.equals("all"))
            h.sendString("Read Permission:<INPUT TYPE=radio CHECKED NAME=readPerm VALUE=all>all&nbsp;\n");
		else
            h.sendString("Read Permission:<INPUT TYPE=radio NAME=readPerm VALUE=all>all&nbsp;\n");

		if(readPerm.equals("passwd"))
            h.sendString("<INPUT TYPE=radio CHECKED NAME=readPerm VALUE=passwd>password required ");
		else
            h.sendString("<INPUT TYPE=radio NAME=readPerm VALUE=passwd>password required ");

        h.sendString("|| Read Password ");
        if(rPassword==null || rPassword.equals(""))
            h.sendString("<INPUT TYPE=text name=rpass cols=20><BR>\n");
        else
            h.sendString("<INPUT TYPE=text name=rpass value="+rPassword+" cols=20><BR>\n");
        h.sendString("&nbsp;&nbsp;&nbsp;<b>Warning:</b> Page passwords, if required, must be non empty.<BR>\n");

        h.sendString("</FORM>\n");

        h.endPage();
        h.flush();
    }

}
