package jwiki;

import java.io.*;
import java.util.*;

/** Does the edit save and cancel function of JWiki **/
public class editsave implements WikiPostable {

    public void handlePOST(JHandler h, byte buf[], int bufSize)
        throws Exception
    {
        // Parse the content part of the request into separate items.
        // The key is the var name and the data is the value of the
        // var.
        Hashtable vars = h.parsePOST(buf, bufSize);

        String fileName = (String)vars.get("file");
        if(fileName == null)
        {
            h.transmitString("No PageName Error",
             "No page name specified in the POST.<BR> The INPUT HTML must be wrong.");
            return;
        }
		

        String Submit = (String)vars.get("Submit");

		h.releaseEditLock(fileName);

		if(Submit.equals("Cancel"))
		{	// Joe Bergin 11/00 added filename
			h.transmitString("Cancel Edit", "Edit of <B><A HREF=\""+fileName+"\">" + fileName + "</A></B> canceled.<P>" +
				"Click the above link to see the new page.\n");
			return;
		}
        
        JWikiCvt.addWord(fileName); // This word is correctly spelled in future. 
        String fileContents = (String)vars.get("txt");
		fileContents = replaceDate(fileContents);

        //OutputStream out = h.getOut();
        h.sendString("HTTP/1.0 200 Ok");
        h.crlf();
        // Headers
        // This keeps the browser from expecting a persistant connection.
        h.sendString("Connection: close");
        h.crlf();      
        h.crlf();

		h.startPage("Save Results", false);
       
        FileOutputStream f;
        
        try
        {
            f = new FileOutputStream(
                h.getParent().getRoot() + File.separator + 
                "docs" + File.separator + fileName);
        }
        catch(Exception oe)
        {
            h.sendString(("<B>Can not open page to save.</B>"));
            h.endPage();
            return;
        }
        
        // Write out the file header and contents. 
        // JoeBergin 11/00, made it a bit more bombproof.
        if(vars.get("html") != null)
            f.write(("html:true\n").getBytes());
        else
        	f.write(("html:false\n").getBytes());    
        if(vars.get("wiki") != null)
            f.write(("wiki:true\n").getBytes());
        else
        	f.write(("wiki:false\n").getBytes());    
        if(vars.get("preamble") != null)
            f.write(("preamble:true\n").getBytes());
        else
        	f.write(("preamble:false\n").getBytes());    
        if(vars.get("postamble") != null)
            f.write(("postamble:true\n").getBytes());
        else
        	f.write(("postamble:false\n").getBytes());    
        if(vars.get("editbutton") != null)
            f.write(("editbutton:true\n").getBytes());
        else 
        	f.write(("editbutton:false\n").getBytes());    
		String readPerm = (String)vars.get("readPerm");
		String writePerm = (String)vars.get("writePerm");
        f.write(("read:" + readPerm + "\n").getBytes());
        f.write(("write:" + writePerm + "\n").getBytes());
		
		if(readPerm.equalsIgnoreCase("passwd"))
        {	String rpassword = (String)vars.get("rpass");
       		if(rpassword != null && !rpassword.equals(""))
        	{	f.write(("rpass:" + rpassword + "\n").getBytes());
        	}
        }
		
		if (writePerm.equalsIgnoreCase("passwd"))
		{	String wpassword = (String)vars.get("wpass");
			if (wpassword != null && !wpassword.equals(""))
			{	f.write(("wpass:" + wpassword + "\n").getBytes());
			}
		}
        h.crlf(f);
        f.write(fileContents.getBytes());
		// Joe Bergin 11/00 Next line.
        h.sendString(("Page <B><A HREF=\""+fileName+"\">" + fileName + "</A></B> saved.<P>"));
 		h.sendString(("Click the above to see the new page.<P>\n"));
		
		// Spell Check -- Joe Bergin
		ArrayList errors = spellCheck(fileContents);
		if (errors != null && errors.size() > 0)
		{	Iterator items = errors.iterator();
			h.sendString("<b>The following words may be misspelled.</b> <br><br>");
			int i = 1;	
			while (items.hasNext())
			{	h.sendString("" + i++ + " " +(String)items.next() + "<br>");
			}		
		}

        h.endPage();
        h.flush();
        
        try { f.close(); } catch (Exception ec) { }
//Mailer.notifier.mail(fileName);
    }

	ArrayList spellCheck(String s)
		throws IOException
    {
    	// This is all in the JWikiCvt class since it's rather large.   
        return JWikiCvt.spellCheck(s);
    }
	
	static String replaceDate(String s)
	{	return JWikiCvt.replaceDate(s);
	}
}
